<?php
/**
 * @package Formidable Autosave
 */
/*
Plugin Name: Teowin Formidable Autosave
Plugin URI: https://teowin-software.nl
Description: Teowin Formidable Autosave adds autosave features to your Formidable Pro forms.
Version: 1.1
Author: Teowin
Author URI: https://www.teowin-software.nl
License: Custom
Text Domain: twAutosave
*/

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

define('TWAUTOSAVE_WOO_PATH',   plugin_dir_path(__FILE__));
define('TWAUTOSAVE_WOO_URL',    plugins_url('', __FILE__));

define('TWAUTOSAVE_WOO_APP_API_URL',  'https://www.teowin-software.nl/index.php');
define('TWAUTOSAVE_WOO_APP_URL',  'https://www.teowin-software.nl');

define('TWAUTOSAVE_WOO_PLUGIN_NAME', 'formidable-autosave.php');

define('TWAUTOSAVE_FULL_NAME', 'formidable-autosave/' . TWAUTOSAVE_WOO_PLUGIN_NAME);

//the Software Unique ID as defined within product admin page
define('TWAUTOSAVE_WOO_PRODUCT_ID', 'twAutosaveFrmPro');

//A code variable constant is required, which is the user application code version. This will be used by API to compare against the new version on shop server.
define('TWAUTOSAVE_WOO_VERSION', '1.1');

$protocol = (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
define('TWAUTOSAVE_WOO_INSTANCE',             str_replace($protocol, "", get_bloginfo('wpurl')));

include(TWAUTOSAVE_WOO_PATH . '/include/class.wooslt.php');
include(TWAUTOSAVE_WOO_PATH . '/include/class.licence.php');
include(TWAUTOSAVE_WOO_PATH . '/include/class.options.php');
include(TWAUTOSAVE_WOO_PATH . '/include/class.updater.php');


add_filter('frm_add_form_settings_section', 'frm_add_new_settings_tab', 10, 2);
function frm_add_new_settings_tab( $sections, $values ) {
	$sections[] = array(
		'name'		=> 'Autosave',
		'anchor'	=> 'autosave',
		'function'	=> 'teowin_autosave_settings',
		/*'class'	=> 'YourClassNamewHere'*/
	);
	return $sections;
}

function teowin_autosave_settings( $values ) {
//	$form_fields = FrmField::getAll('fi.form_id='. (int) $values['id'] ." and fi.type not in ('break', 'divider', 'html', 'captcha', 'form')", 'field_order');
	$autosave_opts = get_option('frm_twautosave_settings_' . $values['id']);
           echo  $autosave_opts;
	?>


    <h3 class="frm_first_h3"><?php _e( 'Autosave', 'twautosave' ); ?>
        <span class="frm_help frm_icon_font frm_tooltip_icon" title="<?php _e('Manage autosave settings for your form.','twautosave');?>'"</span>
    </h3>
	<?php _e('Teowin Autosave adds a autosave feature that will save your form on the frontend automatically.<br/>You can enable it for every form individually.', 'twautosave');
	?>
    <table class="form-table">
        <tr>
            <td width="100px">
                <label><?php _e('Enable Autosave', 'twautosave'); ?></label>
            </td>
            <td>
<?php /*                <!--   <input type="checkbox" name="frm_twautosave_settings[firstopt]" id="frm_twautosave_settings[firstopt]" <?php checked( $autosave_opts['autosave'], 1 ); ?> value='1'> -->
                <input type="checkbox" value="1" id="frm_twautosave_settings" name="frm_twautosave_settings" <?php checked( $autosave_opts['autosave'], 1 ); ?>>                    */ ?>

            <?php /*    <input type="checkbox" value="1" id="frm_twautosave_settings[firstopt]" name="frm_twautosave_settings[firstopt]" <?php checked( $autosave_opts['autosave'], 1 ) ; ?> /> */ ?>
                <input type="checkbox" name="frm_twautosavesettings" id="frm_twautosavesettings" value="1" <?php if ($autosave_opts == 1) { echo "checked='checked'"; } ?> />

            </td>
        </tr>
  <?php /*   <tr>
            <td width="100px">
                <label>old select</label>
            </td>
            <td>
                <select name="frm_twautosave_settings[firstopt]">
                    <option value="><?php _e( '— Select —' ); ?>"</option>
					<?php foreach ( $form_fields as $form_field ) {
						$selected = ( isset( $autosave_opts['firstopt'] ) && $autosave_opts['firstopt'] == $form_field->id ) ? ' selected="selected"' : '';
						?>
                        <option value="<?php echo $form_field->id ?>" <?php echo $selected ?>><?php echo FrmAppHelper::truncate( $form_field->name, 40 ) ?></option>
					<?php } ?>
                </select>
            </td>
        </tr> */ ?>
    </table>
	<?php
}

add_filter('frm_form_options_before_update', 'frm_save_teowin_autosave_settings', 20, 2);
function frm_save_teowin_autosave_settings( $options, $values ){
	if ( isset( $values['frm_twautosavesettings'] ) ) {
		$new_values =  $values['frm_twautosavesettings'] ;
                echo "new values = " . $new_values;
        } else {
             $new_values = 0;
        }

	update_option( 'frm_twautosave_settings_' . $values['id'], $new_values );



	return $options;
}

add_action( 'wp_enqueue_scripts', 'scripts'  );
function scripts() {
	wp_enqueue_script("jquery");
	wp_enqueue_script( 'teowin_autosave', plugin_dir_url( __FILE__ ) . 'js/teowinautosave.js' );
}

add_action('wp_head', 'formidable_autosave_ajaxurl');
function formidable_autosave_ajaxurl() {

	echo '<script type="text/javascript">
           var ajaxurl = "' . admin_url('admin-ajax.php') . '";
         </script>';
}

add_filter( 'frm_display_value', 'display_my_field_value', 10, 3 );
function display_my_field_value( $value, $field, $atts ) {

	if ( $field->field_order != '1'  ) {
		return $value;
	}

    $entry = \FrmEntry::getOne($atts['entry_id']);

    if ($entry->is_draft == '1') {

	    $value = '<div>' . $value . '</div><div style="color:red; font-size: x-small">AutoSaved </div>';
    }

	return $value;
}

add_action('frm_entry_form', 'add_hidden_field');
function add_hidden_field( $form ){

        $formid = $form->id;
	$entrydata = array(
		'form_id'     => $formid,
		'is_draft'    => 1,
		'post_status' => 'draft',
		'entry_key'   => 'AutoSave',
		'frm_user_id' => get_current_user_id(),
	);

	if (! isset($_POST['autosave'])) {
//		$NewEntry = \FrmEntry::create( $entrydata );
           $NewEntry = "";
	}
	else {
           $NewEntry = $_POST['autosave'];
	}

     	$autosave_opts = get_option('frm_twautosave_settings_' . $formid);
        if ( $autosave_opts == 1 ){
           echo '<input type="hidden" id="autosave" name="autosave" value="'. $NewEntry .'">';
        }


}

add_action('wp_ajax_teowin_formidable_autosave', 'teowin_formidable_autosave');
add_action('wp_ajax_nopriv_teowin_formidable_autosave',  'teowin_formidable_autosave');
function teowin_formidable_autosave(){
	global $wpdb;

	$formfields = array();
	parse_str($_POST['form'], $formfields);

	$addnew = $_GET['set'];
	$formid = $formfields['form_id'];

	if (isset($formfields['autosave'])) {
		$entryID = $formfields['autosave'];
	}

	$datafields = $formfields['item_meta'];

	$theform = \FrmForm::getOne($formid);

	$fields = \FrmField::getAll( $wpdb->prepare( 'fi.form_id=%d', $formid ) . " and fi.type not in ('end_divider', 'divider', 'html', 'break', 'captcha', 'rte')", ' ORDER BY field_order' );

	$entry = \FrmEntry::getOne($entryID);

	$newmetas = array();

	$saveentry = false;

	foreach($fields as $thefield){
		if ( array_key_exists($thefield->id, $datafields) )
		{
			$newmetas[$thefield->id] = $datafields[$thefield->id];
			if (!empty($datafields[$thefield->id])){
			    $saveentry = true;
            }
		}

	}

	if ($saveentry == false) {
	   return;
    }

	$entrydata = array(
		'form_id'     => $formid,
		'is_draft'    => 1,
		'post_status' => 'draft',
	//	'name'        => 'AutoSave',
		'frm_user_id' => get_current_user_id(),
		'item_meta'   => $newmetas,
	);

	if ( (empty($entryID) || ($entryID == 0)) && ($addnew == 0 )) {
		$NewEntry = \FrmEntry::create( $entrydata );
	}
	else {
		$NewEntry = $entryID;

		try {
			\FrmEntry::update( $entryID, $entrydata );
		} catch ( Exception $e ) {
			// nothing. just an autsave.
		}
	}
	if(! $NewEntry === false ) {
		echo json_encode( array( 'success' => 1, 'EntryID' => $NewEntry ) );
	} else {
		echo json_encode( array( 'success' => 0, 'EntryID' => 0 ) );
    };

	wp_die();
}

add_action('frm_after_create_entry', 'delete_draft_entry', 42, 2);
function delete_draft_entry($entry_id, $form_id){

	$test = $_POST;

	if (isset($test['frm_action'])) {
		//if ( $test['action'] !== 'teowin_formidable_autosave' ) {
			// don't delete our autosave entries when creating a temporary entry.


			if ( isset( $test['autosave'] ) ) {
				\FrmEntry::destroy( $test['autosave'] );
			}
		//}
	}

	return $entry_id;

}

add_action('wp_ajax_teowin_formidable_autocleanup', 'teowin_formidable_autocleanup');
add_action('wp_ajax_nopriv_teowin_formidable_autocleanup',  'teowin_formidable_autocleanup');
function teowin_formidable_autocleanup(){
	global $wpdb;

	$formfields = array();
	parse_str($_POST['form'], $formfields);

	$formid = $formfields['form_id'];

	if (isset($formfields['autocleanup'])) {
		$entryID = $formfields['autocleanup'];
	}

	$datafields = $formfields['item_meta'];

	$theform = \FrmForm::getOne($formid);

	$entry = \FrmEntry::getOne($entryID);

	$emptyentry = true;

	$newmetas = array();

	foreach($datafields as $thefield => $fieldvalue){

		//	if ( length($datafields[$thefield->id]) == 0){
           if ( ! empty($fieldvalue)  ) {
			    $emptyentry = false;
			    break;
            }
	}

    if ($emptyentry) {
        if ( isset( $formfields['autosave'] ) ) {
            \FrmEntry::destroy( $formfields['autosave'] );
        }
    }
	wp_die();
}


function run_twautosave() {

	global $TWAUTOSAVE_WOO;
	$TWAUTOSAVE_WOO = new TWAUTOSAVE_WOO();
}
run_twautosave();
